const
  xp = 2;
  yp = 16;
var
  s0, s1   : image;
  p        : array[0..4,0..4] of boolean;
  i,j,x,y,n: integer;
  key      : integer;
  count    : integer;
  size     : integer;
  exitCmd, newgCmd, cmd : command;

procedure smile(x,y,n : integer);
begin
  x:=x*size+xp;
  y:=y*size+yp;
  if n=0 then drawImage(s0,x,y)
    else drawImage(s1,x,y);
end;

function check : boolean;
begin
  check := true;
  for i := 0 to 4 do
    for j := 0 to 4 do
      if p[i,j]=false then  check := false;
end;

procedure switch(x,y : integer);
begin
  p[y,x] := not p[y,x];
  for i := 0 to 4 do
  begin
    p[y,i] := not p[y,i];
    p[i,x] := not p[i,x];
  end;
  for i := 0 to 4 do
  begin
    if p[y,i] then smile(i,y,1) else smile(i,y,0);
    if p[i,x] then smile(x,i,1) else smile(x,i,0);
  end;
  repaint;
end;

procedure init;
begin
  y := 0;
  x := 0;
  count := count+1;
  setColor(0,0,0);
  fillRect(0,0,getWidth,getHeight);
  setColor(0,255,0);
  drawText('smile by arT: '+count+' !!!',0,0);
  drawText('ironwoodcutter@bk.ru',0,18);
  delay(800);
  for i := 0 to 4 do
    for j := 0 to 4 do
    begin
      p[i,j] := false;
      smile(i,j,0);
    end;
end;

begin
  showCanvas;
  if ((xp-2+33*5)>getWidth) or ((yp-2+33*5)>getHeight) then
  begin
    s0 := loadImage('/ss0.png');
    s1 := loadImage('/ss1.png');
    size := 16+1;
  end
  else
  begin
    s0 := loadImage('/s0.png');
    s1 := loadImage('/s1.png');
    size := 32+1;
  end;
  exitCmd := createCommand('Exit', CM_EXIT, 1);
  newgCmd := createCommand('New', CM_OK, 1);
  addCommand(exitCmd);
  addCommand(newgCmd);
  randomize;
  count := 0;
  init;
  repeat
    setColor(255,255,255);
    drawRect(x*size+xp-1,y*size+yp-1,size,size);
    repaint;
    delay(100);
    key := keyToAction(getKeyClicked);
    setColor(0,0,0);
    drawRect(x*size+xp-1,y*size+yp-1,size,size);
    if key=GA_UP    then if y>0 then y:=y-1;    {up}
    if key=GA_LEFT  then if x>0 then x:=x-1;    {left}
    if key=GA_RIGHT then if x<4 then x:=x+1;    {right}
    if key=GA_DOWN  then if y<4 then y:=y+1;    {down}
    if key=GA_FIRE  then
    begin
      switch(x,y);
      if check then
      begin
        delay(1000);
        init;
        for n := 0 to 99 do  switch(random(5),random(5));
      end;
    end;
    cmd := getClickedCommand;
    if cmd = newgCmd then begin count := 0; init; end;
  until cmd=exitCmd;
  removeCommand(newgCmd);
  removeCommand(exitCmd);
end.